*
*       LOAD.S
*
*
*
	include	DOSCALL.MAC
	include	IOCSCALL.MAC
	include	JPEG.MAC
	include	work.inc

	.xref	LoadForceContinue

	.text
*
*
	.xref	GetBlock		'GETBLOCK.S'
	.xref	Get_Header		'GETHEAD.S'
	.xref	Memory_error		'ERROR.S'
	.xref	make_UQ_table		'MK_MUL_TBL.S'
*
	.xdef	Load
	.xdef	init_vwork
	.xdef	getmem_1block_line
*
*
Load
*wb_
*----------------------------------
	bsr	Get_Header

	move.w	VSXsize(a6),d1
	move.w	VSYsize(a6),d0
	mulu	d1,d0
	add.l	d0,d0
	move.l	d0,-(sp)
	DOS	_MALLOC
	addq.w	#4,sp
	tst.l	d0
	bmi	Memory_error
	move.l	d0,VSadr(a6)

*tʎqðٍ쐬
*---------------------
	move.w	#1,Qlevel(a6)
	bsr	SetQtable

*WJpܰرm
*----------------------------------
	move.l	free_adrs(a6),a2
	move.l	free_size(a6),d5
	move.l	#load_work_size-em_free_adrs,d1
	adda.l	d1,a2
	sub.l	d1,d5
	bcs	Memory_error

	*WJܰرތvZ
	*--------------------
	move.l	a2,GETP_adrs(a6)
	move.w	HE(a6),d1
	sub.w	HS(a6),d1
	addq.w	#1,d1
	mulu.w	#4*2,d1
	add.l	#12*2,d1
	adda.l	d1,a2
	sub.l	d1,d5
	bcs	Memory_error
	move.l	d1,GETP_size(a6)

	*tʎqZðٍ쐬؊m
	*---------------------
	bsr	make_UQ_table
	move.l	a2,buff_adrs(a6)
	move.l	d5,buff_size(a6)

*  AXyNg̕␳
*-----------------------

	move.w	DCC_bits(a6),d0
	swap.w	d0
	move.w	DCL_bits(a6),d0
	cmp.l	#17*65536+17,d0
	bne	adjust_Aspect_1
	cmp.l	#2*65536+3,Aspect(a6)
	beq	set_Aspect_3_2

adjust_Aspect_1

	cmp.l	#16*65536+16,d0
	bne	adjust_Aspect_end
	cmp.w	#512,Xline(a6)
	bne	adjust_Aspect_end
	cmp.w	#512,Yline(a6)
	bne	adjust_Aspect_end

set_Aspect_3_2

	move.l	#3*65536+2,Aspect(a6)
	bset.b	#7,Sys_flag(a6)	*JPEG.X,JPGS.Xōꂽ摜RGB̍ől252ɂȂȂ
				*̂ł̂߂̕␳ptOiĎۂ͕␳ĂȂj
adjust_Aspect_end

*ʂ̊eܰر
*------------------------
	bsr	init_vwork

*摜WJXN[Ȃꍇ
*------------------------------
load50
	*PubNC̃
	*-------------------------------
	bsr	getmem_1block_line

	bclr.b	#2,Sys_flag2(a6)		XN[Ȃ

load53

*̕\JnƏIʒuvZ
*---------------------------------
	move.w	Xline(a6),d0
	sub.w	XS(a6),d0

	mulu	Interval(a6),d0
	divu	Interval+2(a6),d0	d0=ʏł̃hbg

	*̕\IʒuʓɎ܂悤ɂ
	*---------------------------------------------
load55

	add.w	HS(a6),d0
	subq.w	#1,d0
	move.w	HE(a6),d1		d1=ʏł̉\Iʒu(IvVwŕύX)
	cmp.w	d0,d1
	bhi	load63
	move.w	d1,d0
load63
	move.w	d0,HE(a6)

*c̕\JnƏIʒuvZ
*-----------------------------------
	move.w	Yline(a6),d0
	sub.w	YS(a6),d0
	mulu	Interval+4(a6),d0
	divu	Interval+6(a6),d0

	*c̕\IʒuʓɎ܂悤ɂ
	*---------------------------------------------
load64
	add.w	VS(a6),d0
	subq.w	#1,d0
	move.w	VE(a6),d1
	cmp.w	d0,d1
	bhi	load66
	move.w	d1,d0
load66
	move.w	d0,VE(a6)


*ǂݍ݃obt@̊m
*--------------------------------
	bsr	getmem_file_buf

*	move.l	d0,(sp)

*WJ\
*---------------------------
load83
*	move.l	sp,ErrorStackPoint(a6)
	bsr	GetBlock		摜WJ
	tst.l	d0
	bmi	load_end		I

	move.b	#1,DecodeStatus(a6)


*\I
*-------------------------------
load_end

*	dos	_EXIT
	moveq.l	#0,d0
	bra	LoadForceContinue

*******************************************************************
*
*	ʃTCYAeܰ
*
*******************************************************************
init_vwork

	*  摜̏c,ۯ, ۯ̏cޯĐvZ
	*--------------------------------
	move.w	Xline(a6),d1
	move.w	Yline(a6),d2
	moveq.l	#8,d3
	moveq.l	#8,d4

	addq.w	#7,d1
	addq.w	#7,d2
	lsr.w	#3,d1
	lsr.w	#3,d2

	move.b	uvmode(a6),d0
	subq.b	#1,d0
	beq	@f

	add.w	d3,d3
	addq.w	#1,d1
	bclr.l	#0,d1

	subq.b	#1,d0
	beq	@f

	add.w	d4,d4
	addq.w	#1,d2
	bclr.l	#0,d2
@@
	move.w	d1,BlkX(a6)		̃ubN
	move.w	d2,BlkY(a6)		c̃ubN
	move.w	d3,DeltaX(a6)		1ۯӂ̉ޯĐ
	move.w	d4,DeltaY(a6)		1ۯӂ̏cޯĐ

	*  摜̎gpؗeʂvZ
	*--------------------------------
	lsl.w	#3,d1
	lsl.w	#3,d2
	mulu.w	d1,d2
	add.l	d2,d2			d2=gpe
	move.l	d2,picture_size(a6)

	moveq.l	#0,d1
	move.w	BlkX(a6),d1
	lsl.l	#3+1,d1
	move.l	d1,HScroll_size(a6)
	lsl.l	#3,d1
	move.l	d1,lx(a6)
	move.l	buff_adrs(a6),Scroll_Area(a6)

	moveq.l	#0,d0
	move.w	VSXsize(a6),d0
	add.l	d0,d0
	move.l	d0,VSXbyte(a6)
	rts


*******************************************************************
*
*	PubNC̃
*
*******************************************************************
getmem_1block_line

	move.w	BlkX(a6),d0
	mulu.w	DeltaY(a6),d0
	lsl.l	#3+1,d0
	cmp.l	buff_size(a6),d0
	bcc	Memory_error			mۏoȂ̂ŃG[
	move.l	d0,Scroll_size(a6)
	bset.b	#4,Sys_flag(a6)
	rts

*******************************************************************
*
*	ʉPC̃
*
*******************************************************************
.xdef getmem_1line
getmem_1line
	movea.l	Scroll_Area(a6),a0
	adda.l	Scroll_size(a6),a0
	move.l	a0,VSFile_buf_adrs(a6)
	moveq.l	#0,d0
	move.w	HE(a6),d0
	sub.w	HS(a6),d0
	addq.w	#1,d0
	add.l	d0,d0
	cmp.l	buff_size(a6),d0
	bcc	Memory_error			mۏoȂ̂ŃG[
	move.l	d0,VSFile_buf_size(a6)
	rts

*******************************************************************
*
*	̧ٱޯ̧̊m
*
*******************************************************************
	.xdef	getmem_file_buf
getmem_file_buf
	movea.l	Scroll_Area(a6),a0
	adda.l	Scroll_size(a6),a0
	adda.l	VSFile_buf_size(a6),a0
	move.l	a0,buf_adrs(a6)
	move.l	buff_size(a6),d0
	sub.l	Scroll_size(a6),d0
	bls	Memory_error
	sub.l	VSFile_buf_size(a6),d0
	bls	Memory_error
	cmp.l	#65535,d0
	bls	getmem_file_buf72
	move.l	#65535,d0
getmem_file_buf72
	move.l	d0,buf_size(a6)
	rts

*
  .end

