*
*
*       |Ze[u
*
*
*
include  DOSCALL.MAC
include  IOCSCALL.MAC
include  JPEG.MAC
include	 work.inc

  .text
	.xref	Memory_error
	.xref	DHTDCL	*'MES.S'
	
*
*
* @qfae[u쐬
*
*	
*		Ȃ
*	o
*		Ȃ
*
.xdef	make_RGB_table
make_RGB_table

	movea.l a6,a0
	adda.l  #RGB_TBL+2048*2*6,a0
	move.l	#$f801_07c0,d0
	move.l	#$003e_f801,d1
	move.l	#$07c0_003e,d2
	move.l	d0,d3
	move.l	d1,d4
	move.l	d2,d5

	rept	8
	movem.l	d0-d5,-(a0)
	endm

	moveq.l	#32-1,d7

@@

	rept	8
	movem.l	d0-d5,-(a0)
	endm

	sub.l	#$0001_0000,d0
	move.l	d0,d3
	rept	8
	movem.l	d0-d5,-(a0)
	endm

	subq.w	#1,d1
	move.l	d1,d4
	rept	8
	movem.l	d0-d5,-(a0)
	endm

	sub.l	#$07ff_0040,d0
	sub.l	#$0002_0000,d1
	move.l	d0,d3
	move.l	d1,d4
	rept	8
	movem.l	d0-d5,-(a0)
	endm

	sub.w	#$0000_07ff,d1
	sub.l	#$0040_0002,d2
	move.l	d1,d4
	move.l	d2,d5
	dbra	d7,@b

	movea.l a6,a0
	adda.l  #RGB_TBL_under+RGB_flow*2*6,a0

	moveq.l	#0,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	moveq.l	#0,d3
	moveq.l	#0,d4
	moveq.l	#0,d5

	move.w	#RGB_flow/2/4-1,d7
@@
	movem.l	d0-d5,-(a0)
	movem.l	d0-d5,-(a0)
	movem.l	d0-d5,-(a0)
	movem.l	d0-d5,-(a0)
	dbra.w	d7,@b

	movea.l a6,a0
	adda.l  #RGB_TBL_over+RGB_flow*2*6,a0

	move.l	#$f80107c0,d0
	move.l	#$003ef801,d1
	move.l	#$07c0003e,d2
	move.l	d0,d3
	move.l	d1,d4
	move.l	d2,d5

	move.w	#RGB_flow/2/4-1,d7
@@
	movem.l	d0-d5,-(a0)
	movem.l	d0-d5,-(a0)
	movem.l	d0-d5,-(a0)
	movem.l	d0-d5,-(a0)
	dbra.w	d7,@b
	rts
*
*
* @hcbsZe[u쐬
*
*	
*		Ȃ
*	o
*		Ȃ
*
.xdef	make_IDCT_table
make_IDCT_table

	movea.l a6,a2
	adda.l  #COS_TBL+2048*2*6,a2
	move.w	#4096/2+mul_flow-1,d7
	move.l	#2324419551,a4			cos(pi*6/16)*sqr(2)
	bsr	make_mul_tbl_sub2

	addq.w	#2,a2
	move.w	#4096/2+mul_flow-1,d7
	moveq.l	#1*6*2,d6			cos(pi*2/16)*sqr(2)
	move.l	#1316677908,a4
	bsr	make_mul_tbl_sub

	addq.w	#2,a2
	move.w	#4096/2+mul_flow-1,d7
	moveq.l	#1*6*2,d6			cos(pi/16)*sqr(2)
	move.l	#1662323478,a4
	bsr	make_mul_tbl_sub

	addq.w	#2,a2
	move.w	#4096/2+mul_flow-1,d7
	moveq.l	#1*6*2,d6			cos(pi*3/16)*sqr(2)
	move.l	#755379961,a4
	bsr	make_mul_tbl_sub

	addq.w	#2,a2
	move.w	#4096/2+mul_flow-1,d7
	move.l	#3374534151,a4			cos(pi*5/16)*sqr(2)
	bsr	make_mul_tbl_sub2

	addq.w	#2,a2
	move.w	#4096/2+mul_flow-1,d7
	move.l	#1184978811,a4			cos(pi*7/16)*sqr(2)
*****************************************************************
*
*  IDCTpZe[u쐬2
*
*	
*		a4.l...l̑*65536*65536
*		d7.l...e[uTCY/2
*		a2...e[uAhXiO̒l̂Ƃj
*	o
*		Ȃ
*	j
*		d0,d1,d2,d3,a0,a1,a3
*****************************************************************
make_mul_tbl_sub2

	moveq.l	#0,d0
	moveq.l	#0,d1
	moveq.l	#-6*2,d2
	moveq.l	#6*2,d5

	movea.l a2,a0
	movea.l	a2,a1

@@
	move.w	d1,(a0)
	adda.l	d5,a0

	add.l	a4,d0
	subx.w	d4,d4
	and.w	d5,d4
	add.w	d4,d1
	sub.w	d4,d2

	suba.l	d5,a1
	move.w	d2,(a1)

	dbra	d7,@b
	rts
*****************************************************************
*
*  IDCTpZe[u쐬
*
*	
*		d6.l*65536*65536+a4.l...l̑*65536*65536
*		d7.l...e[uTCY/2
*		a2...e[uAhXiO̒l̂Ƃj
*	o
*		Ȃ
*	j
*		d0,d1,d2,d3,a0,a1,a3
*****************************************************************
make_mul_tbl_sub

	moveq.l	#0,d1

_make_mul_tbl_sub

	moveq.l	#6*2,d5
	moveq.l	#0,d0
	move.l	d1,d2
	sub.l	d5,d2

	movea.l a2,a0
	movea.l	a2,a1

@@
	move.w	d1,(a0)
	adda.l	d5,a0

	add.l	a4,d0
	subx.w	d4,d4
	and.w	d5,d4
	add.w	d6,d4
	add.w	d4,d1
	sub.w	d4,d2

	suba.l	d5,a1
	move.w	d2,(a1)

	dbra	d7,@b
	rts
*
*
*  xtuqfaϊZe[u쐬
*
*	
*		Ȃ
*	o
*		Ȃ
*
.xdef	make_YUV_RGB_table
make_YUV_RGB_table

	movea.l a6,a2
	adda.l  #YUV_RGB_TBL+1024*2*6,a2
	move.w	#2048/2+mul_flow-1,d7
	moveq.l	#-1*6*2,d6				-0.3411*65536*65536
	move.l	#-1465013345,a4
	bsr	make_mul_tbl_sub

	addq.w	#2,a2
	move.w	#2048/2+mul_flow-1,d7
	moveq.l	#1*6*2,d6				1.7718*65536*65536
	move.l	#3314855759,a4
	bsr	make_mul_tbl_sub

	addq.w	#2,a2
	move.w	#2048/2+mul_flow-1,d7
	moveq.l	#1*6*2,d6				1.4020*65536*65536
	move.l	#1726576853,a4
	moveq.l	#R_TBL,d1
	bsr	_make_mul_tbl_sub

	addq.w	#2,a2
	move.w	#2048/2+mul_flow-1,d7
	moveq.l	#-1*6*2,d6				-0.7139*65536*65536
	move.l	#-3066177153,a4
	moveq.l	#G_TBL,d1
	bsr	_make_mul_tbl_sub

	addq.w	#2,a2
	move.w	#2048/2+mul_flow-1,d7
	moveq.l	#-1*6*2,d6				-0.0012*65536*65536
	move.l	#-5153961,a4
	moveq.l	#B_TBL,d1
	bra	_make_mul_tbl_sub

*
*  tʎqZe[u쐬
*
*	
*		a2.l...Zðيi[ڽ
*		d5.l...
*	o
*		a2.l...Zðق̱̎ڽ
*		d5.l...
*
.xdef	make_UQ_table
make_UQ_table

	lea.l	UQL_tbl(a6),a0
	lea.l	QtableL(a6),a1

	moveq.l	#64*2-1,d7	Qtablě
	moveq.l	#0-1,d6		ς݃e[u

	move.w	(a1)+,d1

make_UQ_table_loop

	move.l	#2048,d0
	divs.w	d1,d0

	moveq.l	#0,d2
	move.w	d0,d2
	lsl.w	#1+1,d2
	addq.w	#2+2,d2
	sub.l	d2,d5		d2=̒lðقŏؗ
	bcs	Memory_error		؂Ȃ

	swap.w	d0
	sub.w	#2048,d0

	add.w	d0,d0	*ܰޒPʂ
	add.w	d0,d0
	move.w	d0,d2
	add.w	d0,d0
	add.w	d2,d0	*U{

	add.w	d1,d1	*ܰޒPʂ
	add.w	d1,d1
	move.w	d1,d2
	add.w	d1,d1
	add.w	d2,d1	*U{

@@

	move.w	d0,(a2)+
	add.w	d1,d0
	bne	@b

	move.w	d0,(a2)+	DECODE[`pint}l̂܂܂ƕ̒lS|PĂ邽߂̒pj
	move.l	a2,a3		O̒l̃AhX

@@

	move.w	d0,(a2)+
	add.w	d1,d0

	cmp.w	#2047*2*6,d0
	ble	@b

make_UQ_table_3

	move.l	a3,(a0)+	O̒l̃AhX

	addq.w	#1,d6
	move.w	(a1)+,d1

	lea.l	-2(a1),a4
	movea.l	a0,a3
	move.w	d6,d0

@@

	subq.w	#4,a3
	cmp.w	-(a4),d1
	dbeq.w	d0,@b			lł܂Ō

	dbeq.w	d7,make_UQ_table_loop	lȂ
	move.l	(a3),a3			O̒l̃AhX
	dbne.w	d7,make_UQ_table_3	l
	rts

**********************************************************
*
* X̊ԈE΂ߍ쐬
*
*	
*		d7...ʏ̕\ޯĐ
*	o
*		Ȃ
**********************************************************
.xdef	make_interval_work
make_interval_work

*w̓WJ[`쐬
*-------------------------
	*O
	*-------------------------
	movea.l	GETP_adrs(a6),a5
	move.w	Interval+2(a6),d6
	move.w	Interval(a6),d0
	move.w  d6,a4
	add.w	d0,d6
	move.w	XS(a6),d2	d2=摜̕\Jnʒu

	move.w	d2,d3
	add.w	#$8000,d3
	mulu.w	d0,d3
	move.w	d3,d1
	clr.w	d3
	swap.w	d3
	divu.w	Interval+2(a6),d3
	move.w	d1,d3
	divu.w	Interval+2(a6),d3
	swap.w	d3
	add.w	XL3(a6),d3

	move.w	HX(a6),d1	d1=\JnʒuX
	move.w	d1,d0
	sub.w	Home_X(a6),d0
	and.w	#$1ff,d0	d0=ʂHomeʒu\Jnʒu܂łޯĐ

	sub.w	d0,d7		d7=cޯĐ-1
	subq.w	#1,d7

*\Jnʒȕꍇ̍쐬
*-------------------------
*		tst.w	d2
*		bpl	mk_int_wk_minus_end

*mk_int_wk_minus_end

*	cmp.w	Xline(a6),d2
*	bcc	mk_int_wk_over

*쐬
*-------------------------
		moveq.l	#0,d5
		moveq.l	#0,d0
mk_int_wk_mid
		sub.w	a4,d3
		bcs	mk_int_wk_skip

		cmp.w	#-2,d5
		beq	mk_int_wk_cont

	*̉摜ޯĂɈړꍇ
	*-------------------------
		tst.w	d5
		beq	mk_int_wk_next1

		*ړʂ2޲Ĉȏ̏ꍇ
		*-------------------------
		moveq.l	#0,d0

		cmp.w	#8,d5
		bhi	mk_int_wk_lea	8޲Ĉȏ̈ړȂ̂lea߂g

		and.w	#$0007,d5
		add.w   d5,d5
		lsl.w	#8,d5
		or.w	#$504c,d5
		move.w	d5,(a5)+	'addq.w	#n,a4
		bra	mk_int_wk_next

mk_int_wk_lea
		move.w  #$49ec,(a5)+	'lea.l n(a4),a4'
	        move.w  d5,(a5)+
mk_int_wk_next
		move.w  #$3adc,(a5)+	'move.w (a4)+,(a5)+
		moveq.l	#1,d0
		bra	mk_int_wk_move

		*OޯĂɑꍇ
		*------------------------
mk_int_wk_next1
		bclr.l	#1,d0
		bnz	mk_int_wk_next	VRAM̉E[獶[Ɉړ̂
		tst.w	d0
		beq	mk_int_wk_next	Oɂ'move.l (a4)+,(a5)+'
		bmi	mk_int_wk_next	OޯĂ͈΂Ă

		move.w  #$2adc,-2(a5)	'move.l (a4)+,(a5)+
		moveq.l	#0,d0
		bra	mk_int_wk_move

	*OޯĂƓꍇ
	*-------------------------
mk_int_wk_cont
		tst.w	d0
		bmi	mk_int_wk_cont_cont	OޯẮȂOޯĂƓ
		bclr.l	#1,d0
		bnz	mk_int_wk_cont_round	VRAM̉E[獶[Ɉړ

		*OޯĂƂ̂܂܂ȂĂꍇ
		*--------------------------
		tst.w	d0
		bnz	@f

		move.w  #$201c,-2(a5)	'move.l (a4)+,d0
		move.w  #$2ac0,(a5)+	'move.l d0,(a5)+
		bra	mk_int_wk_cont_cont
@@
		move.w  #$301c,-2(a5)	'move.w (a4)+,d0
		move.w  #$3ac0,(a5)+	'move.w d0,(a5)+
		bra	mk_int_wk_cont_cont

		*OޯĂVRAM̉E[̏ꍇ
		*--------------------------
mk_int_wk_cont_round
		tst.w	d0
		bnz	@f

		move.l  #$201c2ac0,-4(a5)	'move.l (a4)+,d0
						*'move.l d0,(a5)+
		bra	1f
@@
		move.l  #$301c3ac0,-4(a5)	'move.w (a4)+,d0
						*'move.w d0,(a5)+
1:		move.w	#$9bc5,(a5)+		'sub.l d5,a5'

		*OޯẮȂOޯĂƓȏꍇ
		*--------------------------
mk_int_wk_cont_cont

		move.w  #$3ac0,(a5)+	'move.w d0,(a5)+
		moveq.l	#-1,d0

mk_int_wk_move

		moveq.l	#-2,d5
		addq.w	#1,d1
		cmp.w	VSXsize(a6),d1
		bne	@f
		clr.w	d1
		move.w	#$9bc5,(a5)+		'sub.l d5,a5'
		bset.l	#1,d0			VRAM̉E[獶[ɂ܂}[N
@@
		dbra	d7,mk_int_wk_mid
		bra	mk_int_wk50

	*̉摜ޯĂֈړ
	*-----------------------------
mk_int_wk_skip
		add.w	d6,d3
		addq.w  #2,d5
		addq.w	#1,d2
		moveq.l	#$7,d4
		and.w	d2,d4
		bne	@f
		add.w	#(64-8)*2,d5
@@
*		cmp.w	Xline(a6),d2
*		bcc	mk_int_wk_over

		cmp.w	XE(a6),d2
		bls	mk_int_wk_mid
*		bra	mk_int_wk50

mk_int_wk50

	move.w	#$4e75,(a5)+	'rts


*LbṼtbV
*--------------------------
	btst	#0,Sys_flag2(a6)
	beq	mk_int_wk_rts

	*LbVtbV
	*--------------------
	moveq.l	#$3 ,d1		*0)H
				*1)݂̃LbVԂ̓ǂ݂
				*2)H
				*3)LbṼtbV
				*4)LbV̏Ԃݒ肷
	moveq.l	#$ac,d0
	trap	#$0f

mk_int_wk_rts

	rts

  .end
